//
//
//	3d2 files parser class
//
//											(C) 1997 JoOl

#ifndef _PARSER_3D2_H_
#define _PARSER_3D2_H_

#include "ParserBin.h"


class					Parser3d2 : public ParserBin
{


#define SIG_3D2		0x3d02

	typedef struct
	{
		uint16				Sig;
		uint16				NbObj;
		uint16				LightAon, LightBon, LightCon;
		uint16				BrightA, BrightB, BrightC, BrightAmb;
		int16				Az, Bz, Cz;
		int16				Ay, By, Cy;
		int16				Ax, Bx, Cx;
		uint16				ObjColor[32];
		uint16				ColGroup[32];
		uint16				PalType;		// 0 = 7-shade, 1 = 14-shade, 2 = custom
		uint16				WireColor;
		uint16				OutlineColor;
		uint8				Dummy[86];		// should be 150;
	} tHeader3d2;


	tHeader3d2				Header;


	// private parsing methods
	bool					ParseHeader();
	bool					ParseObject();
	bool					ParseVertices();
	bool					ParseFaces();

public:

	Parser3d2(bool = false, int32 = LEXER_BUFLEN, int32 = LEXER_LEXMLEN);
	~Parser3d2();

	virtual bool			SetInput(entry_ref& );

	virtual bool			CheckType();
	virtual bool			Parse();
};


#endif	/* _PARSER_3D2_H_ */



