//
//
//	Basic text-file parser class
//
//											(C) 1997 JoOl


#include "ParserBasic.h"



ParserBasic::ParserBasic(bool V, int32 BufLen, int32 LexmLen): ParserText(V)
{
	Lexr = new LexerBasic(BufLen, LexmLen);
}


ParserBasic::~ParserBasic()
{
	delete Lexr;
}


bool
ParserBasic::CheckType()
{
	return true;
}


bool
ParserBasic::Parse()
{
	while (!Peek(LX_CHAR_EOF))
	{
		if (Peek(LX_TYPE_INTEGER))
		{
			MATCH(LX_TYPE_INTEGER);
			PRINT1("integer %d\n", Lexr->GetTokenValueInt());
		}
		else if (Peek(LX_TYPE_FLOAT))
		{
			MATCH(LX_TYPE_FLOAT);
			PRINT1("float %f\n", Lexr->GetTokenValueFloat());
		}
		else if (Peek(LX_TYPE_STRING))
		{
			MATCH(LX_TYPE_STRING);
			PRINT1("string '%s'\n", Lexr->GetTokenValueStr());
		}
		else if (Peek(LX_TYPE_SYMBOL))
		{
			MATCH(LX_TYPE_SYMBOL);
			PRINT0("symbol");
			PrintSymbol(SearchSymbol(Lexr->GetTokenValueStr()));
		}
		else if (Peek(LX_CHAR_ILLEGAL))
		{
			char			Ill = Lexr->GetIllegalCharacter();
			PRINT2("illegal %d:'%c'\n", int32(Ill), Ill);
			return false;
		}
		else
		{
			MATCH(ParserToken);
			PRINT1("lexeme %s\n", Lexr->GetTokenLexeme(ParserToken));
		}
	}

	Terminate();

	printf("Done...\n");
	return true;
}

