//
//
//	Binary file lexer class
//
//											(C) 1997 JoOl


#ifndef _BIN_LEXER_H_
#define _BIN_LEXER_H_


#include "Lexer.h"



typedef enum
{
	P_BIG_ENDIAN,
	P_LITTLE_ENDIAN
} tEndian;




class					LexerBin : public Lexer
{
	// little/big endian related fields
	tEndian				HardwareEndian;
	tEndian				FileEndian;
	bool				NeedSwap;

#define READ_INT8(a)		if (!ReadInt8(a))		return false
#define READ_INT16(a)		if (!ReadInt16(a))		return false
#define READ_INT32(a)		if (!ReadInt32(a))		return false
#define READ_FLOAT(a)		if (!ReadFloat(a))		return false
#define READ_DOUBLE(a)		if (!ReadDouble(a))		return false
#define READ_BYTES(a, b)	if (!ReadBytes(a, b))	return false
#define READ_STRING(a, b)	if (!ReadString(a, b))	return false
#define SKIP_BYTES(a)		if (!SkipBytes(a))		return false

public:

#pragma export on

	LexerBin(int32, int32);
	~LexerBin();

	virtual bool		SetInput(entry_ref& , tEndian);

	bool				ReadInt8(int8 &);
	bool				ReadInt16(int16 &);
	bool				ReadInt32(int32 &);
	bool				ReadFloat(float &);
	bool				ReadDouble(double &);
	bool				ReadBytes(uint32, char* );
	bool				ReadString(uint32, char* );
	bool				SkipBytes(uint32);
	bool				LexString(uint32, char*& );

#pragma export off

};


#endif	/* _BIN_LEXER_H_ */


