//
//
//	symbol class
//
//											(C) 1997 JoOl


#ifndef _SYMBOL_H_
#define _SYMBOL_H_


typedef union
{
	int32				Int;
	float				Float;
	char*				Str;
} uValue;


enum
{
	LX_KIND_BUILTIN_CONST = 0x0,
	LX_KIND_BUILTIN_TYPE,
	LX_KIND_BUILTIN_PROC,
	LX_KIND_CONST,
	LX_KIND_TYPE,
	LX_KIND_PROC,
	LX_KIND_ARRAY_VAR,
	LX_KIND_SCALAR_VAR,
	LX_KIND_NONE,

	LX_KIND_LAST = LX_KIND_NONE
};


enum
{
	LX_TYPE_INTEGER = 0x200,
	LX_TYPE_FLOAT,
	LX_TYPE_STRING,
	LX_TYPE_SYMBOL,
	LX_TYPE_NONE,

	LX_TYPE_LAST = LX_TYPE_NONE
};



class						Symbol
{

protected:

	char*					Name;
	uint32					Kind;
	uint32					Type;
	uValue					Value;

public:

#pragma export on

	Symbol(char* N, uint32 K, int32 V)
	{
		Name = N;
		Kind = K;
		Type = LX_TYPE_INTEGER;
		Value.Int = V;
	};

	Symbol(char* N, uint32 K, float V)
	{
		Name = N;
		Kind = K;
		Type = LX_TYPE_FLOAT;
		Value.Float = V;
	};

	Symbol(char* N, uint32 K, char* V)
	{
		Name = N;
		Kind = K;
		Type = LX_TYPE_STRING;
		Value.Str = V;
	};
	~Symbol()
	{
		delete[] Name;
		if ((Type == LX_TYPE_STRING) && (Value.Str != NULL))
			delete[] Value.Str;
	};

	void					Clear()
	{
		ClearStr();
		ClearName();
	};
	void					ClearName()
	{	Name = NULL;		};
	void					ClearStr()
	{	Value.Str = NULL;	};

	char*					GetName()
	{ return Name;			};

	uint32					GetKind()
	{ return Kind;			};

	uint32					GetType()
	{ return Type;			};

	int32					GetValueInt()
	{ return Value.Int;		};
	float					GetValueFloat()
	{ return Value.Float;	};
	char*					GetValueStr()
	{ return Value.Str;		};

#pragma export off

};



#endif	/* _SYMBOL_H_ */

